<ui:composition xmlns:ui="http://java.sun.com/jsf/facelets"
                xmlns:a4j="http://richfaces.org/a4j" xmlns:s="http://jboss.org/schema/seam/taglib"
                xmlns:gri="http://java.sun.com/jsf/composite/gri"
                xmlns:f="http://java.sun.com/jsf/core" xmlns:rich="http://richfaces.org/rich"
                xmlns:h="http://java.sun.com/jsf/html"
                xmlns="http://www.w3.org/1999/xhtml">
    <!-- params: managedBean, actorName, transactionName -->
    <!-- inserts: sutSelectionDiv, personIdentifierParameters, addDomainToReturnEdit, additionalReport, displayPatientIdentifier -->
    <h:form id="globalForm">
        <h1>#{actorName}</h1>
        <s:div id="globalDiv">
            <gri:panel>
                <f:facet name="header">#{transactionName}</f:facet>
                <ui:insert name="sutSelectionDiv"/>
                <ui:include src="/testData/_testDataSelection.xhtml">
                    <ui:param name="managedBean" value="#{managedBean}"/>
                    <ui:param name="idsToRender" value="globalDiv"/>
                </ui:include>
                <s:div id="configurationDiv">
                    <gri:panel>
                        <f:facet name="header">#{messages['gazelle.simulator.pam.QueryParameters']}
                            <span class="pull-right">
                                            <h:commandLink actionListener="#{managedBean.initialize()}"
                                                           render="globalForm" execute="@this"
                                                           title="#{messages['gazelle.pam.CleanUpQueryParameters']}">
                                                <s:span styleClass="gzl-icon-times-circle"/>
                                            </h:commandLink>
                                        </span>
                        </f:facet>
                        <h2>#{messages['gazelle.PAMSimulator.PersonIdentifier']}</h2>
                        <s:div id="editParams" rendered="#{managedBean.hl7Messages == null and managedBean.selectedTestData == null}">
                            <ui:insert name="personIdentifierParametersEdit"/>
                        </s:div>
                        <s:div id="viewParam" rendered="#{managedBean.hl7Messages != null or managedBean.selectedTestData != null}">
                            <ui:insert name="personIdentifierParametersDisplay"/>
                        </s:div>
                        <br/>
                        <s:div id="domainsList"
                               rendered="#{not(managedBean.getTestedTransaction().keyword.equals('ITI-83'))}">
                            <h3>#{messages['gazelle.simulator.pam.WhatDomainsReturned']}</h3>
                            <h:outputText
                                    value="#{messages['net.ihe.gazelle.patientmanager.FillTheFormInThePanelBelowToDescribeDomainsToBeR']}"
                                    styleClass="help-block"
                                    rendered="#{managedBean.hl7Messages == null and managedBean.selectedTestData == null}"/>
                            <br/>
                            <div class="row">
                                <div class="col-md-offset-1 col-md-3">
                                    <s:div styleClass="gzl-alert gzl-alert-blue"
                                           rendered="#{empty managedBean.domainsReturned}">
                                        <h:outputText value="#{messages['gazelle.PAMSimulator.QueryForAllDomains']}"/>
                                    </s:div>
                                    <a4j:repeat value="#{managedBean.domainsReturned}" var="aa"
                                                rendered="#{not empty managedBean.domainsReturned}">
                                        <div class="row">
                                            <span class="fa fa-circle-o"/>
                                            <h:outputText
                                                    value="#{aa.namespace}&amp;#{aa.universalId}&amp;#{aa.universalIdType}"
                                                    rendered="#{managedBean.getTestedTransaction().keyword.equals('ITI-9')}"/>
                                            <h:outputText
                                                    value="#{aa.universalId}"
                                                    rendered="#{not managedBean.getTestedTransaction().keyword.equals('ITI-9')}"/>
                                            <span style="width:5px"/>
                                            <a4j:commandLink
                                                    actionListener="#{managedBean.removeAssigningAuthorityFromDomains(aa)}"
                                                    render="domainsList"
                                                    rendered="#{managedBean.hl7Messages == null and managedBean.selectedTestData == null}"
                                                    title="#{messages['gazelle.simulator.pam.RemoveThisDomain']}">
                                                <s:span styleClass="gzl-icon-trash-o "/>
                                            </a4j:commandLink>
                                        </div>
                                    </a4j:repeat>
                                </div>
                                <div class="col-md-offset-1 col-md-7">
                                    <gri:panel
                                            rendered="#{managedBean.hl7Messages == null and managedBean.selectedTestData == null}">
                                        <f:facet name="header">#{messages['net.ihe.gazelle.patientmanager.AddADomainToReturn']}</f:facet>
                                        <ui:insert name="addDomainToReturnEdit"/>
                                        <f:facet name="footer">
                                            <a4j:commandButton
                                                    value="#{messages['gazelle.simulator.pam.AddDomainToList']}"
                                                    actionListener="#{managedBean.addDomainToList()}"
                                                    render="domainsList" styleClass="gzl-btn-green"/>
                                        </f:facet>
                                    </gri:panel>
                                </div>
                            </div>
                        </s:div>
                        <f:facet name="footer">
                            <a4j:commandButton value="#{messages['gazelle.simulator.pam.SendMessage']}"
                                               actionListener="#{managedBean.sendMessage()}"
                                               render="configurationDiv" rendered="#{managedBean.hl7Messages == null}"
                                               styleClass="gzl-btn-blue"/>
                            <a4j:commandButton value="#{messages['net.ihe.gazelle.patientmanager.AddQueryToFavorite']}"
                                               actionListener="#{managedBean.createNewTestData()}"
                                               oncomplete="jq162('#saveTestData').modal('show')"
                                               render="testMetadataContent"
                                               rendered="#{identity.loggedIn and managedBean.selectedTestData == null}"
                                               styleClass="gzl-btn-green"/>
                        </f:facet>
                    </gri:panel>
                    <s:div rendered="#{managedBean.hl7Messages != null}" id="responseDiv">
                        <s:decorate template="/layout/panels/_panel_title.xhtml"
                                    rendered="#{not empty managedBean.receivedIdentifiers}">
                            <ui:define name="panel_title">
                                #{messages['gazelle.PAMSimulator.CorrespondingIdentifiers']}
                            </ui:define>
                            <rich:list value="#{managedBean.receivedIdentifiers}" var="pid" type="unordered">
                                <ui:insert name="displayPatientIdentifier"/>
                            </rich:list>
                        </s:decorate>
                        <ui:insert name="additionalReport"/>
                        <ui:decorate template="/layout/panels/_panel_title_footer.xhtml">
                            <ui:define name="panel_title">#{messages['gazelle.simulator.pam.TestReport']}
                            </ui:define>
                            <ui:include src="/messages/message_table.xhtml">
                                <ui:param name="hl7Messages" value="#{managedBean.hl7Messages}"/>
                            </ui:include>
                            <ui:define name="panel_footer">
                                <a4j:commandButton value="#{messages['gazelle.simulator.pam.PerformAnotherTest']}"
                                                   actionListener="#{managedBean.performAnotherTest()}"
                                                   render="configurationDiv"
                                                   styleClass="gzl-btn-blue"/>
                            </ui:define>
                        </ui:decorate>
                    </s:div>
                </s:div>
            </gri:panel>
            <ui:include src="/testData/_testDataMetadata.xhtml">
                <ui:param name="managedBean" value="#{managedBean}"/>
            </ui:include>
        </s:div>
    </h:form>
</ui:composition>